#include "menu.h"
#include "main.h"
#include <math.h>

Menu::Menu(Main *p)
{
    isResume = false;
    parent = p;
}

Menu::~Menu()
{
}

int Menu::getMenuItemCount()
{
    if (parent->isCheatUnlocked())
    {
	return 4;
    }
    else
    {
	return 3;
    }
}

void Menu::draw (BITMAP *buffer)
{
    clear_to_color (buffer, BLACK);
    draw_rle_sprite (buffer, logo, (buffer->w - logo->w) / 2, 20);
    draw_rle_sprite (buffer, fole, fole_x, fole_y);
    int i;
    for (i = 0; i < getMenuItemCount(); i++)
    {
	int color = CYAN;
	if (i == cursor) color = RED;
	textprintf_centre_ex (buffer, myfont, buffer->w / 2,
	    i * 30 + 100, color, -1, getMenuItem (i).c_str());
    }                
}

void Menu::update()
{
    fole_phase += 0.06;
    fole_x = 152 + (int)(40 * cos(fole_phase / 2));
    fole_y = fole_target_y + (int)(10 * cos(fole_phase * 3));
    int temp = cursor * 30 + 100 - 4;
    if (fole_target_y < temp) { fole_target_y += 2; }
    if (fole_target_y > temp) { fole_target_y -= 2; }
    
    if (keypressed())
    {
	switch (readkey() >> 8)
	{
	    case KEY_ENTER: case KEY_SPACE:
		doMenuItem (cursor);       
		break;
	    case KEY_UP: case KEY_LEFT:
		cursor--;
		parent->playSample (blip);
		if (cursor < 0) cursor = getMenuItemCount() - 1;
		break;                    
	    case KEY_RIGHT: case KEY_DOWN: case KEY_TAB:
		cursor++;
		parent->playSample (blip);
		if (cursor >= getMenuItemCount()) cursor = 0;
		break;                    
	    case KEY_ESC:
		state = 0;
		break;                    
	}
    }
}

void Menu::init()
{ 
    myfont = font;
    fole = parent->getResources()->getRle ("fole");
    logo = parent->getResources()->getRle ("logo");
    miau = parent->getResources()->getSample ("ought");
    blip = parent->getResources()->getSample ("blip");
    
    fole_x = -100;
    fole_y = 120;
    fole_target_y = 120;
    fole_phase = 0.0;
}

string Menu::getMenuItem(int i)
{
    switch (i)
    {
        case 0:
            if (!isResume)
                return string ("Start game");
            else
                return string ("Resume game");
            break;
        case 1:
            return string ("Quit");
        case 2:
            if (parent->isSoundOn())
                return string ("Sound is on");
            else
                return string ("Sound is off");
            break;            
        case 3:
            if (parent->isCheatOn())
                return string ("Cheat is on");
            else
                return string ("Cheat is off");
            break;            
        default:
            assert (false);
    }        
}

void Menu::doMenuItem(int i)
{
    switch (i)
    {
        case 0: // start game
            if (isResume) state = 2; else state = 1;
            break;
        case 1:
            state = 0;
            break;
        case 2:
            parent->setSoundOn (!parent->isSoundOn());            
            break;            
        case 3:
            parent->setCheatOn (!parent->isCheatOn());            
            break;
        default:
            assert (false);
    }      
}

void Menu::initStart()
{
    isResume = false;
    state = -1;
    parent->playMusic ("MMENU");
    cursor = 0;
    clear_keybuf();
}

void Menu::initResume()
{
    isResume = true;
    state = -1;
    parent->playMusic ("MMENU");
    cursor = 0;
    clear_keybuf();
}


